unit usmpview;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Spin, ExtDlgs, Menus, DirDialog,jpeg, inifiles,  math,
  FileCtrl,shellapi,TntClasses, CustomRP, NoBDERP;

const
  szMessageString: pchar = 'pceyes';
  wpBeClose    = 601;
  wpCancel     = 602;
  wpFinilsh    = 603;

type
  TForm1 = class(TForm)
    NoBDEResizerPanel1: TNoBDEResizerPanel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Edit2: TEdit;
    Button2: TButton;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    Button4: TButton;
    Button5: TButton;
    BitBtn1: TBitBtn;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    Label4: TLabel;
    Label12: TLabel;
    Edit3: TEdit;
    Button3: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    BitBtn2: TBitBtn;
    Panel1: TPanel;
    Shape1: TShape;
    Image1: TImage;
    Image3: TImage;
    Label11: TLabel;
    Panel2: TPanel;
    Image2: TImage;
    ColorDialog1: TColorDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs: TMenuItem;
    Exit: TMenuItem;
    DirDialog1: TDirDialog;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    OpenPictureDialog1: TOpenPictureDialog;
    Label10: TLabel;
    SpinEdit5: TSpinEdit;
    SpinEdit6: TSpinEdit;
    Label13: TLabel;
    function ColorToHtmlColor(AColor:TColor):string;
    function HtmlColorToColor(HtmlColor :String):TColor;
    procedure MakeTextFiles;
    procedure MakeImageDir;
    procedure MakethumbImages;
    procedure SetnavDirection;
    procedure SetnavPosition;
    procedure Load;
    procedure save;
    procedure makeData;
    procedure makeXml;
    procedure makeHtml;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ExitClick(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure open1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Shape2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1Click(Sender: TObject);
    procedure Label11Click(Sender: TObject);
    procedure SaveAsClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure SpinEdit4Change(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
    wInitDialogMessage: word;
  protected
    procedure WndProc(var Message: TMessage); override;
  public
    { Public declarations }                            
  end;

var
  Form1: TForm1;
  inifile  :string;
  imaxImageDimension,iframeWidth,istagePadding,ithumbnailColumns,ithumbnailRows ,iImageComprsQulity ,ithumbComprsQulity: integer;
  snavPosition,snavDirection,stitle,simagePath,sthumbPath,sSourceDir,sTargetDir,stextColor,sframeColor,sbgColor : string;
  sTmpData : string; // s_ӵ xml 
  is_ThumbsExeced : boolean=false;(*ˬd thumbs.exe O_v*)
  iWorkStep : integer=0;// 1 ͤjϥ; 2 ͤpϥ; 3  
implementation

{$R *.DFM}

function TForm1.ColorToHtmlColor(AColor:TColor):string;
var
  tmpRGB : TColorRef;
begin
  tmpRGB := ColorToRGB(AColor) ;
  Result:=Format('#%.2x%.2x%.2x',
                 [GetRValue(tmpRGB),
                  GetGValue(tmpRGB),
                  GetBValue(tmpRGB)]) ;
end;

function TForm1.HtmlColorToColor(HtmlColor :String):TColor;
begin
  Result := $00000000;
  if (Length(HtmlColor)=7) and  (HtmlColor[1]='#')
     then Result := RGB(Strtoint('$'+Copy(HtmlColor,2,2))
                       ,Strtoint('$'+Copy(HtmlColor,4,2))
                       ,Strtoint('$'+Copy(HtmlColor,6,2)));
end;



procedure TForm1.makeXml;
var
  sltmpxml   : TTntStringList ;
  mydir : string;
  sHtextColor,  sHframeColor,  sHbgColor : string;

begin
  // oثe]w
  imaxImageDimension := 480;
  iframeWidth        := SpinEdit1.Value;
  istagePadding      := SpinEdit2.Value;
  ithumbnailColumns  := SpinEdit3.Value;
  ithumbnailRows     := SpinEdit4.Value;

  //snavPosition
  //snavDirection

  stitle             := edit2.text;
  simagePath         := '';
  sthumbPath         := '';
  sTargetDir         := edit3.text;
  sHtextColor         := StringReplace(stextColor,'#','0x',[rfReplaceAll, rfIgnoreCase]);
  sHframeColor        := StringReplace(sframeColor,'#','0x',[rfReplaceAll, rfIgnoreCase]);
  sHbgColor           := StringReplace(sbgColor,'#','0x',[rfReplaceAll, rfIgnoreCase]);
  mydir := extractfiledir(application.exename);
  sTargetDir := edit3.text;
  sltmpxml   := TTntStringList.create;
  try
     // Head
     sltmpxml.LoadFromFile(mydir+'\template\tmpxml.txt');
     sltmpxml.text:=StringReplace(sltmpxml.text,'((title))',sTitle,[rfReplaceAll, rfIgnoreCase]);
     sltmpxml.text:=StringReplace(sltmpxml.text,'((maxImageDimension))',inttostr(imaxImageDimension),[rfReplaceAll, rfIgnoreCase]);
     sltmpxml.text:=StringReplace(sltmpxml.text,'((frameWidth))',inttostr(iframeWidth),[rfReplaceAll, rfIgnoreCase]);
     sltmpxml.text:=StringReplace(sltmpxml.text,'((stagePadding))',inttostr(istagePadding),[rfReplaceAll, rfIgnoreCase]);
     sltmpxml.text:=StringReplace(sltmpxml.text,'((thumbnailColumns))',inttostr(ithumbnailColumns),[rfReplaceAll, rfIgnoreCase]);
     sltmpxml.text:=StringReplace(sltmpxml.text,'((thumbnailRows))',inttostr(ithumbnailRows),[rfReplaceAll, rfIgnoreCase]);
     sltmpxml.text:=StringReplace(sltmpxml.text,'((navPosition))',snavPosition,[rfReplaceAll, rfIgnoreCase]);
     sltmpxml.text:=StringReplace(sltmpxml.text,'((navDirection))',snavDirection,[rfReplaceAll, rfIgnoreCase]);
     sltmpxml.text:=StringReplace(sltmpxml.text,'((imagePath))',simagePath,[rfReplaceAll, rfIgnoreCase]);
     sltmpxml.text:=StringReplace(sltmpxml.text,'((thumbPath))',sthumbPath,[rfReplaceAll, rfIgnoreCase]);
     sltmpxml.text:=StringReplace(sltmpxml.text,'((textColor))',sHtextColor,[rfReplaceAll, rfIgnoreCase]);
     sltmpxml.text:=StringReplace(sltmpxml.text,'((frameColor))',sHframeColor,[rfReplaceAll, rfIgnoreCase]);
     sltmpxml.text:=StringReplace(sltmpxml.text,'((bgColor))',sHbgColor,[rfReplaceAll, rfIgnoreCase]);
     // tags  data
     sltmpxml.text:=StringReplace(sltmpxml.text,'((data))',sTmpdata,[rfReplaceAll, rfIgnoreCase]);
     // s
     sltmpxml.SaveToFile(sTargetDir+'\imageData.xml');
  finally
     sltmpxml.free;
  end;
end;

procedure TForm1.makeHtml;
var
  sltmpindex   : TTntStringList ;
  mydir : string;
begin
  sTitle := edit2.text;
  mydir := extractfiledir(application.exename);
  sTargetDir := edit3.text;
  sltmpindex := TTntStringList.create;
  try
    sltmpindex.LoadFromFile(mydir+'\template\tmpindex.txt');
    sltmpindex.text:=StringReplace(sltmpindex.text,'((title))',sTitle,[rfReplaceAll, rfIgnoreCase]);
    sltmpindex.text:=StringReplace(sltmpindex.text,'((bgColor))',sbgColor,[rfReplaceAll, rfIgnoreCase]);
    sltmpindex.SaveToFile(sTargetDir+'\index.html');
  finally
    sltmpindex.free;
  end;
end;

procedure TForm1.makeData;
var
   sltmpdata : tstringlist;
   mydir, sBktmpdata : string;
   sr : TSearchRec;
   mask : String;
begin
  sSourceDir := edit1.text;
  //  d
  mydir := extractfiledir(application.exename);
  sltmpdata  := tstringlist.create;
  try
    sltmpdata.LoadFromFile(mydir+'\template\tmpdata.txt');
    sTmpdata := sltmpdata.text;
    sltmpdata.Clear;
    // ol ؿ ɮ
    mask := '*.jpg';
    if FindFirst(sSourceDir + '\' + mask, faArchive, sr) = 0 then
    begin
      Repeat
        application.ProcessMessages;
        if  (Uppercase(ExtractFileExt(sr.Name)) = '.JPG') then
        begin
            sBkTmpData:=StringReplace(sTmpdata,'((filename))',sr.Name,[rfReplaceAll, rfIgnoreCase]);
            sltmpdata.Append(sBkTmpData);
        end;{-jpg}
      Until FindNext(sr) <> 0;
      FindClose(sr);
    end;(*-FindFirst*)   
    sTmpdata := sltmpdata.Text;
  finally
    sltmpdata.free;
  end;

end;


procedure TForm1.MakeTextFiles;
begin
  //  index.html
  makeHtml;
  //  data
  makedata;
  //  xml
  makexml;
end;

procedure TForm1.MakethumbImages;
var
   mydir : string;
   ParamImage  : string;
begin
   mydir := extractfiledir(application.ExeName);
   sSourceDir := edit1.text;
   sTargetDir := edit3.text;
   // ͤjϥ
   iWorkStep := 1;
   iImageComprsQulity := spinedit6.value;
   ParamImage := sSourceDir+' '+sTargetDir+'\images'+' '+'480'+' '+inttostr(iImageComprsQulity);
   ShellExecute(0,'open',Pchar('thumbs.exe'),Pchar(ParamImage),pchar(mydir),SW_SHOW);
end;

procedure TForm1.MakeImageDir;
var
   sImagesDir , sThumbsDir : string;
begin
   sTargetDir := edit3.text;
   sImagesDir := sTargetDir + '\images';
   sThumbsDir := sTargetDir + '\thumbs';
   if not DirectoryExists(sImagesDir) then
       if not CreateDir(sImagesDir) then
          raise Exception.Create('Lk '+sImagesDir);
   if not DirectoryExists(sThumbsDir) then
       if not CreateDir(sThumbsDir) then
          raise Exception.Create('Lk '+sThumbsDir);
end;


procedure TForm1.SetnavDirection;
begin
   if snavDirection = 'LTR' then
   begin
      ComboBox2.text := 'ѥӥk';
   end
   else
   begin
      ComboBox2.text := 'ѥkӥ';
   end;

end;

procedure TForm1.SetnavPosition;
begin
   if  snavPosition = 'top' then
   begin
     ComboBox1.text := 'W';
   end
   else if snavPosition = 'bottom' then
   begin
     ComboBox1.text := 'U';
   end
   else if snavPosition = 'left' then
   begin
      ComboBox1.text := '';
   end
   else if snavPosition = 'right' then
   begin
      ComboBox1.text := 'k';
   end;
end;

procedure TForm1.save;
var n:tinifile;
begin

  n:=tinifile.create(inifile);
  n.WriteString('Data','SourceDir',edit1.text);
  n.WriteString('Data','navPosition',snavPosition);
  n.WriteString('Data','navDirection',snavDirection);
  n.WriteInteger('Data','thumbnailColumns',SpinEdit3.value);
  n.WriteInteger('Data','thumbnailRows',SpinEdit4.value);
  n.WriteString('Data','textColor',stextColor);
  n.WriteString('Data','frameColor',sframeColor);
  n.WriteString('Data','bgColor',sbgColor);
  n.WriteString('Data','Title',edit2.text);
  n.WriteString('Data','TargetDir',edit3.text);
  n.WriteInteger('Data','frameWidth',SpinEdit1.Value);
  n.WriteInteger('Data','stagePadding',SpinEdit2.Value);
  n.WriteInteger('Data','ImageComprsQulity',SpinEdit6.Value);
  n.WriteInteger('Data','ThumbComprsQulity',SpinEdit5.Value);
  n.free;

end;

procedure TForm1.load;
var n:tinifile;
begin
    n:=tinifile.create(inifile);
    edit1.text:=n.ReadString('Data','SourceDir','C:\');
    snavPosition:=n.ReadString('Data','navPosition','right');
    snavDirection:=n.ReadString('Data','navDirection','LTR');
    SpinEdit3.value := n.ReadInteger('Data','thumbnailColumns',3);
    SpinEdit4.value := n.ReadInteger('Data','thumbnailRows',3);
    stextColor :=n.ReadString('Data','textColor','#FFFFFF');
    sframeColor:=n.ReadString('Data','frameColor','#FFFFFF');
    sbgColor   :=n.ReadString('Data','bgColor','#181818');
    edit2.text := n.ReadString('Data','Title','Title');
    edit3.text := n.ReadString('Data','TargetDir','c:\temp');
    SpinEdit1.Value := n.ReadInteger('Data','frameWidth',20);
    SpinEdit2.Value := n.ReadInteger('Data','stagePadding',40);
    SpinEdit5.Value := n.ReadInteger('Data','ThumbComprsQulity',40);
    SpinEdit6.Value := n.ReadInteger('Data','ImageComprsQulity',65);
    n.free;
end;


procedure TForm1.Button3Click(Sender: TObject);
begin
  if DirDialog1.Execute then
  begin
     edit3.text := DirDialog1.DirName;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   if OpenPictureDialog1.Execute then
   begin
      edit1.text := ExtractFileDir(OpenPictureDialog1.filename);
   end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
     Shape1.Brush.Color := ColorDialog1.Color;
     sbgColor := ColorToHtmlColor(ColorDialog1.Color);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    wInitDialogMessage := RegisterWindowMessage(szMessageString);
    inifile:=extractfilepath(application.exename)+'smpview.ini';
    image1.Picture.Bitmap.TransparentColor := clblack;
    image1.Transparent := true;
    image3.Picture.Bitmap.TransparentColor := clblack;
    image3.Transparent := true;
    load;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
     label11.font.Color := ColorDialog1.Color;
     stextColor := ColorToHtmlColor(ColorDialog1.Color);

  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
     Panel2.Color := ColorDialog1.Color;
     sframeColor :=ColorToHtmlColor(ColorDialog1.Color);
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    
    save;
end;

procedure TForm1.ExitClick(Sender: TObject);
begin
     form1.Close;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
    save;
end;

procedure TForm1.open1Click(Sender: TObject);
var
   mydir : string;
begin
   mydir := extractfiledir(application.exename);
   OpenDialog1.InitialDir := mydir;
   if OpenDialog1.Execute then
   begin
      copyfile(pchar(OpenDialog1.FileName),pchar(extractfilepath(application.exename)+'smpview.ini'), false);
      formCreate(nil);
      formActivate(nil);
   end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
   SetnavPosition;
   SetnavDirection;
   ComboBox1Change(nil);
   label11.font.color := HtmlColorToColor(stextColor);
   panel2.Color := HtmlColorToColor(sframeColor);
   shape1.Brush.Color := HtmlColorToColor(sbgColor);



end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
   if ComboBox1.text = 'W'  then
   begin
      snavPosition := 'top';
      panel2.left :=36;
      panel2.top :=42;
      image3.left :=56;
      image3.top :=16;
   end
   else if ComboBox1.text = 'U' then
   begin
      snavPosition := 'bottom';
      panel2.left :=36;
      panel2.top :=16;
      image3.left :=60;
      image3.top :=60;
   end
   else if ComboBox1.text = '' then
   begin
      snavPosition := 'left';
      panel2.left :=56;
      panel2.top :=32;
      image3.left :=16;
      image3.top :=40;

   end
   else if ComboBox1.text = 'k' then
   begin
      snavPosition := 'right';
      panel2.left :=16;
      panel2.top :=32;
      image3.left :=104;
      image3.top :=40;
   end;


end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
   if ComboBox2.text = 'ѥӥk' then
   begin
      snavDirection := 'LTR';
   end
   else
   begin
      snavDirection := 'RTL';
   end;

end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
     label11.caption := edit2.text;
end;

procedure TForm1.Shape2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   Button4.Click;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
    Button2.Click;
end;

procedure TForm1.Label11Click(Sender: TObject);
begin
  Button5.Click;
end;

procedure TForm1.SaveAsClick(Sender: TObject);
begin
  save;
  savedialog1.InitialDir := extractfilepath(application.exename);
  if SaveDialog1.Execute then
  begin
     copyfile(pchar(extractfilepath(application.exename)+'smpview.ini'),pchar(SaveDialog1.filename), false)
  end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
 mydir : string;
begin
   mydir := extractfiledir(application.exename);
   sTargetDir := edit3.text;
   if not CheckBox1.Checked then
   begin
      //  images M thumbs ؿ
       MakeImageDir;
       // ͹
       MakethumbImages;
       BitBtn1.Enabled := false; (*Tws  *)
   end;
   // קݩ
   MakeTextFiles;
   if not fileexists(sTargetDir+'\viewer.swf') then
   begin
      copyfile(Pchar(mydir+'\flashview\viewer.swf'),Pchar(sTargetDir+'\viewer.swf'),true);
      copyfile(Pchar(mydir+'\flashview\upgrade.html'),Pchar(sTargetDir+'\upgrade.html'),true);
      copyfile(Pchar(mydir+'\flashview\flash_detect.js'),Pchar(sTargetDir+'\flash_detect.js'),true);
      copyfile(Pchar(mydir+'\flashview\get_flash_player.gif'),Pchar(sTargetDir+'\get_flash_player.gif'),true);
   end;
   // ͹ɮɤ~|@
   if CheckBox1.Checked then
   begin
       // 
       if CheckBox2.Checked then
       begin
         ShellExecute(0,'open',Pchar(sTargetDir+'\index.html'),nil,pchar(sTargetDir),SW_SHOWMAXIMIZED);
       end;(*-CheckBox2.Checked*)
   end;
end;

procedure TForm1.SpinEdit3Change(Sender: TObject);
begin
    ithumbnailColumns  := SpinEdit3.Value;
end;

procedure TForm1.SpinEdit4Change(Sender: TObject);
begin
      ithumbnailRows     := SpinEdit4.Value;
end;

procedure TForm1.WndProc(var Message: TMessage);
var
  Paramthumb, mydir : string;
begin
  //
  if (Message.Msg = wInitDialogMessage)and
     (inttostr(Message.wParam) <> inttostr(Handle))  then
  begin
  ReplyMessage(0);



   case Message.lParam of
   wpFinilsh :
            begin
              (*u@*)
              Case iWorkStep of
              1:
                 begin
                   mydir := extractfiledir(application.ExeName);
                   sSourceDir := edit1.text;
                   sTargetDir := edit3.text;
                   // ͤpϥ
                   iWorkStep := 2;
                   iThumbComprsQulity := spinedit5.value;
                   Paramthumb := sTargetDir+'\images'+' '+sTargetDir+'\thumbs'+' '+'60'+' '+inttostr(ithumbComprsQulity);
                   ShellExecute(0,'open',Pchar('thumbs.exe'),Pchar(Paramthumb),Pchar(mydir),SW_SHOW);
                 end;(*1*)
              2:
                 begin
                   // 
                   iWorkStep := 3;
                   if CheckBox2.Checked then
                   begin
                     ShellExecute(0,'open',Pchar(sTargetDir+'\index.html'),nil,pchar(sTargetDir),SW_SHOWMAXIMIZED);
                   end;(*-CheckBox2.Checked*)
                   // Lצp󳣭n
                   BitBtn1.Enabled := true;
                 end;(*-2*)
              end;(*Case iWorkStep*)
            end;(*wfinislsh*)
   wpCancel :
            begin
              (*ϥΪ̨*)
              BitBtn1.Enabled := true;
            end;
   end;

  end;
  inherited WndProc(Message);
end;


procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
     SendMessage(HWND_BROADCAST, wInitDialogMessage, Handle, wpBeClose);
end;

end.
